import java.util.LinkedList;
import java.util.NoSuchElementException;

public class StackLL<T> {
	
	private LinkedList<T> stack;
	
	public StackLL() {
		this.stack = new LinkedList<T>();
	}
	
	//is this stack empty?
	public boolean isEmpty() {
		return this.stack.isEmpty();
	}
	
	//add t to the top of this stack
	public void push(T t) {
		this.stack.addFirst(t);
	}
	
	//remove the top element of this stack
	T pop() throws NoSuchElementException {
		if(this.isEmpty())
			throw new NoSuchElementException("Can't pop an empty stack");
		else {
			T removeElement = this.stack.removeFirst();
			return removeElement;
		}
	}
	
	//peek at the item at the top of this stack
	public T peek() throws NoSuchElementException {
		if(this.isEmpty())
			throw new NoSuchElementException("Can't pop an empty stack");
		else
			return this.stack.getFirst();
	}

}
