import java.util.ArrayList;
import java.util.NoSuchElementException;

public class StackAL<T> {
	
	private ArrayList<T> stack;
	
	public StackAL() {
		this.stack = new ArrayList<T>();
	}
	
	//is this stack empty?
	public boolean isEmpty() {
		return this.stack.isEmpty();
	}
	
	//add t to the top of this stack
	public void push(T t) {
		this.stack.add(t);
	}
	
	//remove the top element of this stack
	T pop() throws NoSuchElementException {
		if(this.isEmpty())
			throw new NoSuchElementException("Can't pop an empty stack");
		else {
			T removeElement = this.stack.remove(this.stack.size() - 1);
			return removeElement;
		}
	}
	
	//peek at the item at the top of this stack
	public T peek() throws NoSuchElementException {
		if(this.isEmpty())
			throw new NoSuchElementException("Can't pop an empty stack");
		else
			return this.stack.get(this.stack.size() - 1);
	}

}
